/* randspeed.c
 * Small Programm to test speed of different PRNGs
 *
 * Copyright 2004, Holger Fuessler <fuessler@informatik.uni-mannheim.de>
 *
 * $Id: randspeed.c,v 1.2 2004/05/06 15:01:08 fuessler Exp $
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <glib.h>

#define NO_OF_DRAWS 100000000

void run(int number){
	if (number == 1){
		long i;
		int value;
		printf("Initializing rand()\n");
		srand(0);
		printf("Drawing %d times...\n", NO_OF_DRAWS);
		for (i = 0; i < NO_OF_DRAWS; i++){
			value = rand();
		}
	}

	if (number == 2){
		long i;
		int value;
		printf("Initializing random()\n");
		srandom(0);
		printf("Drawing %d times...\n", NO_OF_DRAWS);
		for (i = 0; i < NO_OF_DRAWS; i++){
			value = random();
		}
	}

	if (number == 3){
		GRand * gprng;
		long i;
		int value;
		printf("Initializing grand() Mersenne Twister\n");
		gprng = g_rand_new();
		printf("Drawing %d times...\n", NO_OF_DRAWS);
		for (i = 0; i < NO_OF_DRAWS; i++){
			value = g_rand_int(gprng);
		}
		g_rand_free(gprng);
	}


} /* EO run() */

int main (int argc, char** argv)
{
	if (argc != 2){
		fprintf(stderr, "Call with randspeed <RNG>\n, with RNG=1 (rand()), 2 (mt(glib))\n");
		exit(1);
	}

	run(atoi(argv[1]));
	
	printf("Done!\n");
	exit(-1);
} /* EO main */
